# Copyright 2012-2014 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type


from colander import (
    Boolean,
    MappingSchema,
    SchemaNode,
)

from charmworld.search import BUNDLE


def get_schema(kind):
    """Based on the kind return the right schema."""
    if kind == BUNDLE:
        return BundleFeaturedness()
    return CharmFeaturedness()


class CharmFeaturedness(MappingSchema):
    is_featured = SchemaNode(
        Boolean(), title='Feature this charm',
        missing=False)


class BundleFeaturedness(MappingSchema):
    is_featured = SchemaNode(
        Boolean(), title='Feature this bundle',
        missing=False)
