# use ngrams
import logging

from charmworld.models import CharmSource

from charmworld.search import (
    IndexMissing,
    update,
)


def upgrade(db, index_client):
    """db is the pymongo db instance for our datastore. Charms are in db.charms
    for instance.

    index_client is the ElasticSearch client.
    """
    log = logging.getLogger('migration_027')
    log.warning('Starting')
    charm_source = CharmSource(db, index_client)
    try:
        index_client.delete_index()
        log.warning("deleted index")
    except IndexMissing:
        # It is already updated.
        pass
        log.warning("Index already deleted")
    update(index_client)
    cids = charm_source.sync_index()
    while True:
        try:
            next(cids)
        except StopIteration:
            break
    log.warning("Index updated")
